// Event-driven simulation of IF neurons
// (as in Mirollo/Strogatz 90)
//
// R. Brette (brette@di.ens.fr)
// Feb 2006

exec('EventDriven.sci');

tau=20;
V0=12;
Vt=10;

function X=fUpdate(X,t)
// X(:,1) = V (membrane potential)
// X(:,2) = time of last spike
  X(:,1)=V0+(X(:,1)-V0).*exp(-(t-X(:,2))/tau);
  X(:,2)=t;
endfunction

function t=fNextSpike(X)
//  t=zeros(size(X,1),1);
//  ind1=find(X(:,1)>=Vt);
//  t(ind1)=X(ind1,2);
//  
//  if V0>Vt
//    ind2=find(X(:,1)<Vt);
//    t(ind2)=X(ind2,2)+tau*log((X(ind2,1)-V0)/(Vt-V0));
//  else
//    t(find(X(:,1)<Vt))=-1;
//  end
  if (X(1)>=Vt)
    t=X(2);
  else
    if V0>Vt
      t=X(2)+tau*log((X(1)-V0)/(Vt-V0));
    else
      t=-1;
    end
  end
endfunction

function X=fOutgoingSpike(X)
  X(:,1)=0;
endfunction

function X=fIncomingSpike(X,w,t)
  X(:,1)=X(:,1)+w;
endfunction

N=40;
X=[grand(N,1,'def')*8,zeros(N,1)];
W=ones(N,N)*0.01;
T=zeros(N,1);
timer();
spikes=EventDriven(X,W,T,fUpdate,fNextSpike,fOutgoingSpike,fIncomingSpike,1000);
timer()

clf;
plot(spikes(:,2),spikes(:,1),'.');

